//---------------------------------------------------------------------------------------------
// Torque Game Builder
// Copyright (C) GarageGames.com, Inc.
//---------------------------------------------------------------------------------------------
//
// This is the file you should define your custom datablocks that are to be used
// in the editor.
//

//------------------------------------------------------------------------------
// The touch target indicator
//------------------------------------------------------------------------------
datablock t2dSceneObjectDatablock( TouchTargetIndicatorConfig )
{
	layer = "0";
   	size = "16 16";   
	imageName = touchtarget;

   	collisionActiveSend = false;
   	collisionActiveReceive = false;
   	collisionPhysicsSend = false;
   	collisionPhysicsReceive = false;
};

//------------------------------------------------------------------------------
// SpawnPoints
//------------------------------------------------------------------------------

datablock t2dSceneObjectDatablock( SpawnPointConfig )
{
   	class = "SpawnPoint";
	layer = "0";
   	size = "20 20";   

   	collisionActiveSend = false;
   	collisionActiveReceive = false;
   	collisionPhysicsSend = false;
   	collisionPhysicsReceive = false;
};

datablock t2dSceneObjectDatablock( DoctorSpawnPointConfig : SpawnPointConfig )
{
   	class = "DoctorSpawnPoint";
   	superclass = "SpawnPoint";
};

datablock t2dSceneObjectDatablock( NurseSpawnPointConfig : SpawnPointConfig )
{
   	class = "NurseSpawnPoint";
   	superclass = "SpawnPoint";
};

datablock t2dSceneObjectDatablock( PowerupSpawnPointConfig : SpawnPointConfig )
{
   	class = "PowerUpSpawnPoint";
   	superclass = "SpawnPoint";
   	size = "32 32";   

	// finger interaction
    _behavior0 = "TouchListenerBehavior	notifyTouchDown	1	notifyTouchRelease	1";
    _behavior1 = "TouchIndicatorBehavior	indicator	TTARGET";
    _behavior2 = "TouchSoundBehavior	soundFile	game-click";
};

//------------------------------------------------------------------------------
// Pathing objects
//------------------------------------------------------------------------------

datablock t2dSceneObjectDatablock( PathGridConfig )
{
   	//layer = 30;
	visible = false;

	collisionPolyList = "0.00 0.00 0.00 0.00 0.00 0.00 0.00 0.00";	
	//collisionPolyList = "-1.00 -1.00 1.00 -1.00 1.00 1.00 -1.00 1.00";	
   	collisionResponseMode = CLAMP;
   	collisionActiveSend = false;
   	collisionActiveReceive = false;
   	collisionPhysicsSend = false;
   	collisionPhysicsReceive = false;
   	collisionGroups = 0;
};

datablock t2dSceneObjectDatablock( PathDestinationConfig )
{
	// this is a trigger
   	class = "Destination";

   	size = "10.0 10.0";   

	EnterCallback = true;
    StayCallback = false;
    LeaveCallback = true;

	collisionPolyList = "-1.00 -1.00 1.00 -1.00 1.00 1.00 -1.00 1.00";	
   	collisionResponseMode = CLAMP;
   	collisionActiveSend = true;
   	collisionActiveReceive = true;

   	graphGroup = 1;
   	collisionGroups = BIT(1);

	// direction references
	//dirIdle = "0 1"; // direction to face when "idle"
	dirBusy = "1 0"; // direction to face when "busy"
	
	targetParent = NULL;
};

datablock t2dSceneObjectDatablock( BedDestinationConfig : PathDestinationConfig )
{
   	graphGroup = 3;
	collisionGroups = BIT(1) | BIT(2);
};

datablock t2dSceneObjectDatablock( DoctorEntryDestinationConfig : PathDestinationConfig )
{
   	class = "DoctorEntryDestination";
   	superclass = "Destination";
   	graphGroup = 1;
	collisionGroups = BIT(1);
    LeaveCallback = false;
};

datablock t2dSceneObjectDatablock( GarbageDestinationConfig : PathDestinationConfig )
{
   	graphGroup = 1;
	collisionGroups = BIT(1) | BIT(2);
	targetParent = GARBAGE1;
};

datablock t2dSceneObjectDatablock( NurseIdleDestinationConfig )
{
	// this is a trigger
   	class = "NurseIdlePoint";
	superclass = "Destination";

   	size = "10.0 10.0";   

	EnterCallback = true;
    StayCallback = false;
    LeaveCallback = true;

	collisionPolyList = "-1.00 -1.00 1.00 -1.00 1.00 1.00 -1.00 1.00";	
   	collisionResponseMode = CLAMP;
   	collisionActiveSend = true;
   	collisionActiveReceive = true;

   	graphGroup = 4;
   	collisionGroups = BIT(2);
};

//------------------------------------------------------------------------------
// Floor
//------------------------------------------------------------------------------

datablock t2dSceneObjectDatablock( FloorConfig )
{
	layer = 22;
	//size = "480 320";
	position = "16 96";
	size = "512 512";
};

datablock t2dSceneObjectDatablock( DoorShadowConfig )
{
	size = "128.0 78.0";
	sortPoint = "0.0 1.0";
	//layer = 0;
	//layer = 20;
	layer = 22;
	//layer = 11;

   	animationName = anim_door_grey_closed_shadow;
};

datablock t2dSceneObjectDatablock( DoorConfig )
{
	class = "Door";
	//layer = 10;
	layer = 21;
	size = "92 78";
	sortPoint = "0.0 0.5";
	animationName = anim_door_grey_closed;
	
	animationOpen = anim_door_grey_open;
	animationClosed = anim_door_grey_closed;

	enableShadow = true;
	shadowPoint = "-0.4 0.0";
	shadowAlphaBlend = 0.1;
	shadowConfig = DoorShadowConfig;

	enableReflect = true;
	reflectPoint = "0.0 0.8";
	reflectYScale = 0.5;
	reflectAlphaBlend = 0.1;

	// finger interaction
    //_behavior0 = "TouchListenerBehavior	notifyTouchDown	0	notifyTouchRelease	1";
};

datablock t2dSceneObjectDatablock( DoorToggleTriggerConfig )
{
	class = "DoorToggleTrigger";
	layer = 10;
	size = "90 100";

	EnterCallback = true;
	StayCallback = false;
	LeaveCallback = false;

	collisionPolyList = "-1.00 -1.00 1.00 -1.00 1.00 1.00 -1.00 1.00";	
	collisionResponseMode = CLAMP;
	collisionActiveSend = true;
	collisionActiveReceive = true;

	graphGroup = 2;
	collisionGroups = BIT(2);
	
	door = DOOR1;
};

datablock t2dSceneObjectDatablock( DoorToggleTriggerDoctorConfig )
{
	class = "DoorToggleTrigger";
	layer = 10;
	size = "90 10";

	EnterCallback = true;
	StayCallback = false;
	LeaveCallback = false;

	collisionPolyList = "-1.00 -1.00 1.00 -1.00 1.00 1.00 -1.00 1.00";	
	collisionResponseMode = CLAMP;
	collisionActiveSend = true;
	collisionActiveReceive = true;

	graphGroup = 1;
	collisionGroups = BIT(1);
	
	door = DOOR1;
};

//------------------------------------------------------------------------------
// Beds
//------------------------------------------------------------------------------

datablock t2dSceneObjectDatablock( Bed1Config )
{
   	class = "Bed";
	superclass = "MoveTarget";

   	layer = 10;
   	size = "49 90"; 
	//sortPoint = "0 -0.3";
	sortPoint = "0 -0.5";
	
	animationName = anim_bed_empty;

	// collision data
	collisionPolyList = "-1.00 -1.00 1.00 -1.00 1.00 1.00 -1.00 1.00";	
   	collisionResponseMode = CLAMP;
   	collisionActiveSend = false;
   	collisionActiveReceive = false;
   	collisionPhysicsSend = false;
   	collisionPhysicsReceive = false;

	// finger interaction
    _behavior0 = "TouchListenerBehavior	notifyTouchDown	1	notifyTouchRelease	0";
    _behavior1 = "TouchIndicatorBehavior	indicator	TTARGET";
    _behavior2 = "TouchSoundBehavior	soundFile	game-click";
    _behavior3 = "PulseBehavior	Time	0.150";
	
	// lp 1: patient head
	// lp 2: patient health bar
	// lp 3: iv location
	// lp 4: heart monitor
	// lp 5: breathing machine
	// lp 6: status icon
    LinkPoints = "0.000 -0.398 0.000 0.760 1.073 -0.756 -0.433 -0.850 0.532 -0.850 0.000 0.570";

	// link points
	linkPointHead = "0.000 -0.398";
	linkPointHealthBar = "0.000 0.760";
	linkPointStatus = "0.000 0.570";
//	linkPointIV = "1.073 -0.756";
//	linkPointMachine1 = "-0.433 -0.850";
//	linkPointMachine2 = "0.532 -0.850";
	linkPointIV = "1.073 -0.450";
	linkPointMachine1 = "-0.633 -0.850";
	linkPointMachine2 = "0.633 -0.850";
//	linkPointTV = "-0.800 0.150";
	linkPointTV = "-1.400 0.150";

	// the bed slot number (1 to 6)
	slot = 1;

	// state of the bed: 0 - empty, 1 - full, 2 - dirty
  	state = 0;
	animEmpty = anim_bed_empty;
	animFull = anim_bed_full;
	animFullToDirty = anim_bed_dirty;
	animDirtyToEmpty = anim_bed_clean;

	// the activity currently being performed
	// 0 - none, 1 - diagnosing, 2 - diagnosis complete, 3 - diagnosis taken, 4 - healing, 5 - healed
	activity = 0;

	patient = 0;
	
	// graphic settings for indicating that the bed can accept a patient
	emptyIndicatorConfig = BedEmptyIndicatorConfig;
	linkPointEmptyIndicator = "0.000 -0.398";
	
	// audio
	stateChangeAudio = "patientstatechange";
	audioVolume = 1.0;
	
	// doctor-patient interaction effects
	enableEffects = true;
	effectFile = "~/data/particles/portal.eff";
   	effectTime = 0.5;
   	effectAudio = 0;//spawnAudio;
   	spawnDelayMS = 1000;	

	// what beds are adjacent for the purpose of contractable diseases
	adjacent = "";
};

datablock t2dSceneObjectDatablock( Bed2Config : Bed1Config )
{
	slot = 2;
};

datablock t2dSceneObjectDatablock( Bed3Config : Bed1Config )
{
	slot = 3;
};

datablock t2dSceneObjectDatablock( Bed4Config : Bed1Config )
{
	slot = 4;
};

datablock t2dSceneObjectDatablock( Bed5Config : Bed1Config )
{
	slot = 5;
};

datablock t2dSceneObjectDatablock( Bed6Config : Bed1Config )
{
	slot = 6;
};


//------------------------------------------------------------------------------
// Sink
//------------------------------------------------------------------------------

datablock t2dSceneObjectDatablock( SinkConfig )
{
	class = "Sink";
	superclass = "MoveTarget";

   	layer = 18;
	size = "32 24";

	animationName = anim_sink_idle;

	// collision data
	collisionPolyList = "-1.00 -1.00 1.00 -1.00 1.00 1.00 -1.00 1.00";	
   	collisionResponseMode = CLAMP;
   	collisionActiveSend = false;
   	collisionActiveReceive = false;
   	collisionPhysicsSend = false;
   	collisionPhysicsReceive = false;

	// finger interaction
    _behavior0 = "TouchListenerBehavior	notifyTouchDown	1	notifyTouchRelease	0";
    _behavior1 = "TouchIndicatorBehavior	indicator	TTARGET	yOffset 8";
    _behavior2 = "TouchSoundBehavior	soundFile	game-click";
    _behavior3 = "PulseBehavior	Time	0.150";

	// the amount of dirt applied to the doctor per visit (positive is clean, negative is dirt)
	dirt = 20;
	dirtBonus = 5;
	dirtBonusApply = -50;
	dirtPenalty = -5;
	dirtPenaltyApply = 50;
	
	awardableTimerMs = 2000;
};

//------------------------------------------------------------------------------
// Garbage
//------------------------------------------------------------------------------

datablock t2dSceneObjectDatablock( GarbageShadowConfig )
{
	size = "32.0 64.0";
	sortPoint = "0.0 1.0";
	layer = 11;

   	animationName = anim_garbage_closed_shadow;
};

datablock t2dSceneObjectDatablock( GarbageConfig )
{
	class = "Garbage";
	superclass = "MoveTarget";
	size = "32.0 58.0";

   	layer = 10;

	animationName = anim_garbage_closed;
	sortPoint = "0.0 0.7";
	
	animationOpen = anim_garbage_open;
	animationClose = anim_garbage_close;
	animationClosed = anim_garbage_closed;
	
	enableShadow = true;
	shadowPoint = "-0.3 -0.1";
	shadowAlphaBlend = 0.1;
	shadowConfig = GarbageShadowConfig;

	enableReflect = true;
	reflectPoint = "0.0 1.2";
	reflectYScale = 0.5;
	reflectAlphaBlend = 0.1;

	// collision data
	collisionPolyList = "-1.00 -1.00 1.00 -1.00 1.00 1.00 -1.00 1.00";	
   	collisionResponseMode = CLAMP;
   	collisionActiveSend = false;
   	collisionActiveReceive = false;
   	collisionPhysicsSend = false;
   	collisionPhysicsReceive = false;

	// finger interaction
    _behavior0 = "TouchListenerBehavior	notifyTouchDown	1	notifyTouchRelease	0";
    _behavior1 = "TouchIndicatorBehavior	indicator	TTARGET";
    _behavior2 = "TouchSoundBehavior	soundFile	game-click";
    _behavior3 = "PulseBehavior	Time	0.150";

	// the amount of dirt applied to the doctor per visit (positive is clean, negative is dirt)
	dirt = 10;
	dirtBonus = 5;
	dirtBonusApply = -50;
	dirtPenalty = -5;
	dirtPenaltyApply = 50;
	
	awardableTimerMs = 2000;
};

datablock t2dSceneObjectDatablock( GarbageFlipXConfig : GarbageConfig )
{
	//flipX = true;
	flipX = false;
};

//------------------------------------------------------------------------------
// Drop-Off and Pharmacy
//------------------------------------------------------------------------------

datablock t2dSceneObjectDatablock( ComputerShadowConfig )
{
	layer = 19;
	size = "64 64";
	animationName = anim_computer_shadow;
};

datablock t2dSceneObjectDatablock( ComputerConfig )
{
	class = "Computer";
	superclass = "MoveTarget";

   	layer = 18;
	size = "64 64"; // full size
	//size = "58 58"; // 90%

	animationName = anim_computer_off;
	animationOn = anim_computer_on;
	animationOff = anim_computer_off;

	turnOffDelay = 1000;

	enableShadow = true;
	shadowPoint = "-0.3 0.0";
	shadowAlphaBlend = 0.5;
	shadowConfig = ComputerShadowConfig;

	// collision data
	collisionPolyList = "-1.00 -1.00 1.00 -1.00 1.00 1.00 -1.00 1.00";	
   	collisionResponseMode = CLAMP;
   	collisionActiveSend = false;
   	collisionActiveReceive = false;
   	collisionPhysicsSend = false;
   	collisionPhysicsReceive = false;

	// finger interaction
    _behavior0 = "TouchListenerBehavior	notifyTouchDown	1	notifyTouchRelease	0";
    _behavior1 = "TouchIndicatorBehavior	indicator	TTARGET	xOffset	-8";
    _behavior2 = "TouchSoundBehavior	soundFile	game-click";
    _behavior3 = "PulseBehavior	Time	0.150";
};

datablock t2dSceneObjectDatablock( PharmacyConfig )
{
	class = "Pharmacy";
	superclass = "MoveTarget";

   	layer = 19;

	// collision data
	collisionPolyList = "-1.00 -1.00 1.00 -1.00 1.00 1.00 -1.00 1.00";	
   	collisionResponseMode = CLAMP;
   	collisionActiveSend = false;
   	collisionActiveReceive = false;
   	collisionPhysicsSend = false;
   	collisionPhysicsReceive = false;

	// finger interaction
    _behavior0 = "TouchListenerBehavior	notifyTouchDown	1	notifyTouchRelease	0";
    _behavior1 = "TouchIndicatorBehavior	indicator	TTARGET";
    _behavior2 = "TouchSoundBehavior	soundFile	game-click";
};

datablock t2dSceneObjectDatablock( PharmacySlot1Config )
{
	class = "PharmacySlot";
	
   	layer = 18;
	//size = "24 24";
	size = "16 16";

	// collision data
	collisionPolyList = "-1.00 -1.00 1.00 -1.00 1.00 1.00 -1.00 1.00";	
   	collisionResponseMode = CLAMP;
   	collisionActiveSend = false;
   	collisionActiveReceive = false;
   	collisionPhysicsSend = false;
   	collisionPhysicsReceive = false;

	// the slot number (1 to 6 max)
	slot = 1; 

	// indicates that the slot is empty
	//empty = true;

	// the prescription that is in the slot, if there is one
	prescription = NULL;
};

datablock t2dSceneObjectDatablock( PharmacySlot2Config : PharmacySlot1Config )
{
	slot = 2;
};

datablock t2dSceneObjectDatablock( PharmacySlot3Config : PharmacySlot1Config )
{
	slot = 3;
};

datablock t2dSceneObjectDatablock( PharmacySlot4Config : PharmacySlot1Config )
{
	slot = 4;
};

datablock t2dSceneObjectDatablock( PharmacySlot5Config : PharmacySlot1Config )
{
	slot = 5;
};

datablock t2dSceneObjectDatablock( PharmacySlot6Config : PharmacySlot1Config )
{
	slot = 6;
};

datablock t2dSceneObjectDatablock( PharmacyPathConfig )
{
	class = "PharmacyPath";
	
	randomWaitMin = 2000;
	randomWaitMax = 5000;
};

//------------------------------------------------------------------------------
// Patient Spawners and Seats
//------------------------------------------------------------------------------

datablock t2dSceneObjectDatablock( PatientSpawnerConfig )
{
	class = "PatientSpawner";

	size = "35 35";
	
	// indicates that the spawner is disabled, unwilling to spawn any more patients
	disabled = false;
	
	// specifies if the spawner is automatic (true) or triggered (false)
	auto = true;
	
	// specifies if a spawn is to occur on level load or if it should wait until an interval event
	levelLoadSpawn = true;
	
	// the minimum number of seconds that must pass between patient selections (only used for auto mode)
	minInterval = 10.0;
	
	// the maximum number of seconds that must pass between patient selections (only used for auto mode)
	maxInterval = 20.0;
	
	// specifies that the spawner chooses from the patient set randomly 
	random = false; 
	
	// specifies that the spawner removes the patient from the set once chosen (true) or keeps it in the set (false)
	remove = true; 

	// the patient sim set that the spawner pulls patients from
	patientSet = PatientSimSet; 
};

datablock t2dSceneObjectDatablock( PatientSpawnerManualConfig : PatientSpawnerConfig )
{
	remove = true;
	random = false;
	auto = false;
	levelLoadSpawn = false;
};

datablock t2dSceneObjectDatablock( PatientSpawnerForeverRandomConfig : PatientSpawnerConfig )
{
	remove = false;
	random = true;
};

datablock t2dSceneObjectDatablock( PatientSpawnerSingleConfig : PatientSpawnerConfig )
{
	remove = true;
};

//------------------------------------------------------------------------------
// Text
//------------------------------------------------------------------------------

/*
datablock t2dSceneObjectDatablock( ScoreDisplayConfig )
{
	layer = 3;

	font = "Airstrip Four";
    wordWrap = "0";
    hideOverflow = "0";
    textAlign = "Center";
    lineHeight = "16";
    aspectRatio = "1";
    lineSpacing = "0";
    characterSpacing = "1";
    autoSize = "1";
    fontSizes = "32";

	// FFD700 (gold)
    textColor = "1.000 0.843 0.000 1.000";
};

datablock t2dSceneObjectDatablock( ClockDisplayConfig )
{
	class = "Clock";
	layer = 3;

	countDown = true;
	runDelay = 0;
	//rate = 1;
	
	font = "Airstrip Four";
    wordWrap = "0";
    hideOverflow = "0";
    textAlign = "Center";
    lineHeight = "16";
    aspectRatio = "1";
    lineSpacing = "0";
    characterSpacing = "1";
    autoSize = "1";
    fontSizes = "32";

    textColor = "1 1 1 1";
};
*/

datablock t2dSceneObjectDatablock( MachineQuantityConfig )
{
	layer = 2;

	font = "Airstrip Four";
    wordWrap = "0";
    hideOverflow = "0";
    textAlign = "Center";
    lineHeight = "16";
    aspectRatio = "1";
    lineSpacing = "0";
    characterSpacing = "1";
    autoSize = "1";
    fontSizes = "32";

    textColor = "0.9 0.9 0.9 1";
};

datablock t2dSceneObjectDatablock( DefaultTextConfig )
{
	layer = 2;

	font = "Airstrip Four";
    wordWrap = "0";
    hideOverflow = "0";
    textAlign = "Center";
    lineHeight = "18";
    aspectRatio = "1";
    lineSpacing = "0";
    characterSpacing = "1";
    autoSize = "1";
    fontSizes = "18";

    textColor = "1 1 1 1";
};

/*
datablock t2dSceneObjectDatablock( FloatyScoreBorderConfig )
{
	layer = 9;
	offsetX = 0;
	offsetY = -5.0;
	deltaY = -25.0;
	floatSpeed = 25.0;
	
    font = "Airstrip Four";
    wordWrap = "0";
    hideOverflow = "0";
    textAlign = "Center";
    lineHeight = "18";
    aspectRatio = "1";
    lineSpacing = "0";
    characterSpacing = "0";
    autoSize = "1";
    fontSizes = "32";
    textColor = "1 1 1 1";
};
*/

datablock t2dSceneObjectDatablock( FloatyScoreConfig )
{
	layer = 9;
	offsetX = 0;
	offsetY = -15.0;
	deltaY = -25.0;
	floatSpeed = 25.0;
	
    font = "Airstrip Four";
    wordWrap = "0";
    hideOverflow = "0";
    textAlign = "Center";
    lineHeight = "16";
    aspectRatio = "1";
    lineSpacing = "0";
    characterSpacing = "1";
    autoSize = "1";
    fontSizes = "32";

	// FFD700 (gold)
    textColor = "1.000 0.843 0.000 1.000";
	// greenish
    //textColor = "0.15 0.91 0.15 1";
};

datablock t2dSceneObjectDatablock( FloatyCleanlinessPositiveConfig )
{
	layer = 9;
	offsetX = 0;
	offsetY = -20.0;
	deltaY = -25.0;
	floatSpeed = 25.0;
	
    font = "Airstrip Four";
    wordWrap = "0";
    hideOverflow = "0";
    textAlign = "Center";
    lineHeight = "14";
    aspectRatio = "1";
    lineSpacing = "0";
    characterSpacing = "0";
    autoSize = "1";
    fontSizes = "32";

    textColor = "0.15 0.91 0.15 0.8"; // greenish
    //textColor = "0.694 0.816 0.808 0.5"; // light blue
    //textColor = "0.196 0.443 0.435 0.8"; // dark bluish
};

datablock t2dSceneObjectDatablock( FloatyCleanlinessNegativeConfig : FloatyCleanlinessPositiveConfig)
{
	textColor = "0.643 0.165 0.078 0.5";
};

//------------------------------------------------------------------------------
// SoundEmitter
//------------------------------------------------------------------------------

datablock t2dSceneObjectDatablock( SoundEmitterConfig )
{
   class = "SoundEmitter";

   // By putting the sound emitter on a different
   // graph group we're blocking it from collision
   // queries... this is a savings in collision 
   // processing.
   graphGroup = 15;

   profile = 0;
   volume = 1;
   playOnce = false;
   ambient = false;
};

//------------------------------------------------------------------------------
// General/Debug
//------------------------------------------------------------------------------

datablock t2dSceneObjectDatablock( DebugNurseMoveTargetConfig )
{
	class = "MoveTarget";

   	layer = 10;
	moveObjRef = NURSE1;

	// collision data
	collisionPolyList = "-1.00 -1.00 1.00 -1.00 1.00 1.00 -1.00 1.00";	
   	collisionResponseMode = CLAMP;
   	collisionActiveSend = false;
   	collisionActiveReceive = false;
   	collisionPhysicsSend = false;
   	collisionPhysicsReceive = false;

	// finger interaction
    _behavior0 = "TouchListenerBehavior	notifyTouchDown	0	notifyTouchRelease	1";
};
